# DeploymentEnvironment

All deployment environment endpoints

## GET /v3/deploymentEnvironment

> Get the details of all your deployment environment

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentEnvironment":{"type":"object","required":["id","name","createdAt"],"properties":{"id":{"type":"string","format":"","description":"Deployment environment ID","readOnly":true},"name":{"type":"string","format":"","description":"The public name of your deployment environment"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get the details of all your deployment environment","operationId":"getDeploymentEnvironments","parameters":[{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentEnvironment"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/deploymentEnvironment

> Create a deployment environment

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentEnvironment":{"type":"object","required":["id","name","createdAt"],"properties":{"id":{"type":"string","format":"","description":"Deployment environment ID","readOnly":true},"name":{"type":"string","format":"","description":"The public name of your deployment environment"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment":{"post":{"tags":["DeploymentEnvironment"],"summary":"Create a deployment environment","operationId":"createDeploymentEnvironment","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentEnvironment"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentEnvironment"}}}}},"403":{"description":"Invalid credentials"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentEnvironment/{deploymentEnvironmentId}

> Get the details of the given deployment environment

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentEnvironment":{"type":"object","required":["id","name","createdAt"],"properties":{"id":{"type":"string","format":"","description":"Deployment environment ID","readOnly":true},"name":{"type":"string","format":"","description":"The public name of your deployment environment"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get the details of the given deployment environment","operationId":"getDeploymentEnvironment","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentEnvironment"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/deploymentEnvironment/{deploymentEnvironmentId}

> Update given deployment environment

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentEnvironment":{"type":"object","required":["id","name","createdAt"],"properties":{"id":{"type":"string","format":"","description":"Deployment environment ID","readOnly":true},"name":{"type":"string","format":"","description":"The public name of your deployment environment"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}":{"put":{"tags":["DeploymentEnvironment"],"summary":"Update given deployment environment","operationId":"updateDeploymentEnvironment","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentEnvironment"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentEnvironment"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## DELETE /v3/deploymentEnvironment/{deploymentEnvironmentId}

> Delete given deployment environment

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}":{"delete":{"tags":["DeploymentEnvironment"],"summary":"Delete given deployment environment","operationId":"deleteDeploymentEnvironment","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"409":{"description":"Cannot delete"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentEnvironment/{deploymentEnvironmentId}/fleet

> Get all the active fleets that belong to the given deployment environment.

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Fleet":{"type":"object","required":["id","name","deploymentEnvironmentId","operationalStatus","isGameLift"],"properties":{"id":{"type":"string","format":"","description":"Fleet ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the fleet"},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID to which the fleet is assigned"},"deploymentProfileId":{"type":"string","format":"","description":"The `DeploymentProfileTemplate`'s ID, used for scaling, that is attached to this `Fleet`"},"gameDeploymentTemplateId":{"type":"string","format":"","description":"The `GameDeploymentTemplate`'s ID that is attached to this `Fleet`"},"utilityDeploymentTemplateId":{"type":"string","format":"","description":"The `UtilityDeploymentTemplate`'s ID that is attached to this `Fleet`"},"dependencyDeploymentTemplateId":{"type":"string","format":"","description":"The `DependencyDeploymentTemplate`'s ID that is attached to this `Fleet`"},"hostCapacityTemplateId":{"type":"string","format":"","description":"The `HostCapacityTemplate`'s ID that is attached to this `Fleet`"},"operationalStatus":{"type":"integer","format":"integer","description":"0: Manual, 1: Automatic deployment enabled, 2: Automatic scaling enabled (implies automatic deployment)","readOnly":true},"isGameLift":{"type":"boolean","description":"When it is active it cannot be disabled anymore"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}/fleet":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get all the active fleets that belong to the given deployment environment.","operationId":"getDeploymentEnvironmentFleets","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Fleet"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentEnvironment/{deploymentEnvironmentId}/host

> Get all your hosts for given deployment environment

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Host":{"type":"object","required":["id","userId","serverId","serverName","serverType","liveHostName","isVirtual","category","osId","locationId","dcLocationId","instanceType","fleetId","newFleetId","fleetAssociatedSince","rackName","dateStart","dateEnd","dateCancelled","dateEndContract","contractPeriod","extendPeriod","cancellationPeriod","purchaseOrder","paymentTerm","pricePerMonth","pricePerTbOveruse","currencyId","bandwidthBillingType","bandwidthContractual","ipAddress","brand","model","numCpu","cpuInfo","cpuType","cpuLoad","cpu","memUsed","memMax","memFree","disk","memory","isReserve","serviceTag","isODP","fmOrderId","installStatus","status","trafficSum","uplinks","freeIncomingTraffic","outgoingTrafficSum","incomingTrafficSum"],"properties":{"id":{"type":"integer","format":"integer","description":"The ID of this host","readOnly":true},"userId":{"type":"integer","format":"integer","description":"The ID of the user who owns this server","readOnly":true},"serverId":{"type":"integer","format":"integer","description":"The ID of the physical machine","readOnly":true},"serverName":{"type":"string","format":"","description":"The name of the physical machine","readOnly":true},"serverType":{"type":"integer","format":"integer","description":"The type of the server:\n* 1: Bare metal server\n* 2: Flex metal server\n* 3: Virtual machine","readOnly":true},"projectName":{"type":"string","format":"","description":"The name of the project for the host"},"clientServerName":{"type":"string","format":"","description":"The name of the server defined by client"},"clientState":{"type":"string","format":"","description":"Client statement for the host"},"liveHostName":{"type":"string","format":"","description":"The host name","readOnly":true},"isVirtual":{"type":"integer","format":"integer","description":"0 if this is a bare metal server, 1 if it's a VM. Use `serverType` instead","readOnly":true,"deprecated":true},"category":{"type":"string","format":"","description":"Host category. Normally \"Dedicated Game Servers\" or \"Dedicated Servers\", but can be \"Broken\" if the server is in a degraded state","readOnly":true},"osId":{"type":"integer","format":"integer","description":"Operating system ID, must be one of [`GET /v3/operatingsystem`](all#/OperatingSystem/getOperatingsystems)","readOnly":true},"locationId":{"type":"integer","format":"integer","description":"Legacy location ID (not used for ODP)","readOnly":true},"dcLocationId":{"type":"integer","format":"integer","description":"Datacenter location ID. Points to one of [`GET /v3/cloud/dcLocation`](#/Cloud/getCloudDcLocations)","readOnly":true},"instanceType":{"type":"string","format":"","description":"The instance type of this server, which is one of [`GET /v3/host/instanceType`](#/Host/getHostInstanceTypes) for a bare metal, or one of\n[`GET /v3/cloud/instanceType`](#/Cloud/getCloudInstanceTypes) for a virtual machine","readOnly":true},"fleetId":{"type":"string","format":"","description":"The fleet ID, if this host has been assigned to a fleet\nIf `0`, the host has not been assigned to a fleet, otherwise, the fleet is assigned to this host and the host can serve application instances for that fleet.","readOnly":true},"newFleetId":{"type":"string","format":"","description":"The ID of a new fleet that is to be assigned to this host after performing a bulkReserve operation at [`POST /v3/fleet/host/bulkReserve`](#/Fleet/createFleetHostBulkReserve)","nullable":true,"readOnly":true},"fleetAssociatedSince":{"type":"integer","format":"integer","description":"Unix timestamp when fleet assigned to the host","readOnly":true},"rackName":{"type":"string","format":"","description":"The name of the rack the host is located","readOnly":true},"dateStart":{"type":"string","format":"","description":"The date at which this host became active","readOnly":true},"dateEnd":{"type":"string","format":"","description":"The date at which this host will expire","readOnly":true},"dateCancelled":{"type":"string","format":"","description":"The date at which this host was cancelled","readOnly":true},"dateEndContract":{"type":"string","format":"","description":"The date at which the contract ends (if applicable)","readOnly":true},"contractPeriod":{"type":"integer","format":"integer","description":"The contract period in months","readOnly":true},"extendPeriod":{"type":"integer","format":"integer","description":"The service extend period in months","readOnly":true},"cancellationPeriod":{"type":"integer","format":"integer","description":"The cancellation period in months","readOnly":true},"purchaseOrder":{"type":"string","format":"","description":"Purchase order, if one has been supplied via our billing department","readOnly":true},"paymentTerm":{"type":"integer","format":"integer","description":"The payment term in days (how many days are invoices generated before dateEnd)","readOnly":true},"pricePerMonth":{"type":"string","format":"","description":"The price of this host per month in cents (see `currencyId` for currency)","readOnly":true},"pricePerTbOveruse":{"type":"string","format":"","description":"The price of traffic overuse in cents (per TB) (see `currencyId` for currency)","readOnly":true},"currencyId":{"type":"integer","format":"integer","description":"The currency of the `pricePerMonth` field:\n* 0: EURO\n* 1: USD\n* 9: YEN","readOnly":true},"bandwidthBillingType":{"type":"integer","format":"integer","description":"The bandwidth billing method for this service:\n* 1: unmetered connection\n* 2: measured in TB per month\n* 3: measured in mbit 95th percentile","readOnly":true},"bandwidthContractual":{"type":"integer","format":"integer","description":"The contractual maximum bandwidth usage value. In GB if bandwidthBillingType equals `2`, in mbit otherwise","readOnly":true},"ipAddress":{"type":"array","items":{"$ref":"#/components/schemas/HostIP"},"description":"All IP addresses assigned to this host","readOnly":true},"brand":{"type":"string","format":"","description":"The server manufacturer brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model of the server","readOnly":true},"numCpu":{"type":"integer","format":"integer","description":"Number of CPUs in this host","readOnly":true},"cpuInfo":{"type":"string","format":"","readOnly":true},"cpuType":{"type":"string","format":"","readOnly":true},"cpuLoad":{"type":"number","format":"float","description":"Percentage of cpu used across all cores","readOnly":true},"cpu":{"allOf":[{"$ref":"#/components/schemas/HostCpu"}],"readOnly":true},"memUsed":{"type":"integer","format":"integer","description":"The amount of memory that is used by the host (in megabytes)","readOnly":true},"memMax":{"type":"integer","format":"integer","description":"The amount of memory that is available on the host (in megabytes)","readOnly":true},"memFree":{"type":"integer","format":"integer","description":"The amount of free memory that is available on the host (in megabytes)","readOnly":true},"disk":{"type":"array","items":{"$ref":"#/components/schemas/HostDisk"},"readOnly":true},"memory":{"type":"array","items":{"$ref":"#/components/schemas/HostMemory"},"readOnly":true},"isReserve":{"type":"integer","format":"integer","description":"If the host is reserved for a fleet isReserve set to 1","readOnly":true},"labels":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for host"},"serviceTag":{"type":"string","format":"","description":"The service tag of the host","readOnly":true},"isODP":{"type":"integer","format":"integer","description":"If the host is available for game hosting platform isODP set to 1","readOnly":true},"fmOrderId":{"type":"string","format":"","description":"ID of Flex Metal order if this is a flex metal server","nullable":true,"readOnly":true},"installStatus":{"type":"string","format":"","description":"Status of server auto install if it was started by one. (created / installing / finished / failed)","nullable":true,"readOnly":true},"status":{"type":"string","format":"","description":"Whether the host is running or not","readOnly":true},"uptime":{"type":"integer","format":"integer","description":"The uptime of the host. Read-only. Only provided if the server checked-in recently"},"trafficSum":{"type":"integer","format":"integer","description":"Monthly traffic of all incoming and outgoing bandwidth in GB or Mbit depending on host configuration","readOnly":true},"uplinks":{"type":"array","items":{"$ref":"#/components/schemas/HostUplink"},"description":"A list of uplinks attached to this host","readOnly":true},"freeIncomingTraffic":{"type":"boolean","description":"Whether the host has free incoming traffic or not","readOnly":true},"outgoingTrafficSum":{"type":"integer","format":"integer","description":"The outgoing traffic (Mbit or GB)","readOnly":true},"incomingTrafficSum":{"type":"integer","format":"integer","description":"The incoming traffic (Mbit or GB)","readOnly":true}},"additionalProperties":false},"HostIP":{"type":"object","required":["ipAddress","version","type","private","interface","macAddress","rDns","vlanId","gateway","netmask","prefix"],"properties":{"ipAddress":{"type":"string","format":"","description":"Host IP address","readOnly":true},"version":{"type":"integer","format":"integer","description":"IP version, possible values can be 4 or 6","readOnly":true},"type":{"type":"integer","format":"integer","description":"IP type:\n1) normal,\n2) KVM,\n253) VRRP1,\n254) VRRP2,\n255) gateway","readOnly":true},"private":{"type":"integer","format":"integer","description":"Private IP (1) or public IP (0)","readOnly":true},"interface":{"type":"integer","format":"integer","description":"ID of the interface (0-7)","readOnly":true},"macAddress":{"type":"string","format":"","description":"MAC address of the interface","readOnly":true},"rDns":{"type":"string","format":"","description":"RDNS of the interface","readOnly":true},"vlanId":{"type":"integer","format":"integer","description":"ID for the VLAN","nullable":true,"readOnly":true},"gateway":{"type":"string","format":"","description":"Interface gateway","nullable":true,"readOnly":true},"netmask":{"type":"string","format":"","description":"Interface netmask","nullable":true,"readOnly":true},"prefix":{"type":"integer","format":"integer","description":"Interface prefix","nullable":true,"readOnly":true}},"additionalProperties":false},"HostCpu":{"type":"object","required":["socket","cores","threads","info","type"],"properties":{"socket":{"type":"integer","format":"integer","description":"Number of populated CPU sockets","readOnly":true},"cores":{"type":"integer","format":"integer","description":"Total number of cores (sum of all CPU cores)","readOnly":true},"threads":{"type":"integer","format":"integer","description":"Total number of threads (sum of all CPU threads).","readOnly":true},"info":{"type":"string","format":"","description":"CPU information","readOnly":true},"type":{"type":"string","format":"","description":"CPU type","readOnly":true}},"additionalProperties":false},"HostDisk":{"type":"object","required":["diskType","diskMedium","model","product","diskSerial","firmwareVersion","rotationRate","sectorSizeLogical","sectorSizePhysical","size"],"properties":{"diskType":{"type":"string","format":"","description":"The type of disk","readOnly":true},"diskMedium":{"type":"string","format":"","description":"The medium of this disk","readOnly":true},"model":{"type":"string","format":"","description":"The model name of this disk","readOnly":true},"product":{"type":"string","format":"","description":"The product string of this disk","readOnly":true},"diskSerial":{"type":"string","format":"","description":"The serial number of this disk","readOnly":true},"firmwareVersion":{"type":"string","format":"","description":"Firmware version","readOnly":true},"rotationRate":{"type":"integer","format":"integer","description":"Rotation rate (does not apply to SSD)","readOnly":true},"sectorSizeLogical":{"type":"integer","format":"integer","description":"Logical sector size","readOnly":true},"sectorSizePhysical":{"type":"integer","format":"integer","description":"Physical sector size","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true}},"additionalProperties":false},"HostMemory":{"type":"object","required":["brand","model","size","speed","ecc","memoryBank","memoryType","memorySlot","memorySerial"],"properties":{"brand":{"type":"string","format":"","description":"The brand name","readOnly":true},"model":{"type":"string","format":"","description":"The model name","readOnly":true},"size":{"type":"integer","format":"integer","description":"In bytes","readOnly":true},"speed":{"type":"integer","format":"integer","description":"The speed this memory module runs at","readOnly":true},"ecc":{"type":"integer","format":"integer","description":"Set to 1 if ecc is supported and enabled","readOnly":true},"memoryBank":{"type":"integer","format":"integer","description":"The bank this module sits in","readOnly":true},"memoryType":{"type":"string","format":"","description":"The type of memory module","readOnly":true},"memorySlot":{"type":"string","format":"","description":"The slot this module sits in","readOnly":true},"memorySerial":{"type":"string","format":"","description":"The serial number of this module","readOnly":true}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"HostUplink":{"type":"object","required":["uplinkId","aggregate"],"properties":{"uplinkId":{"type":"integer","format":"integer","description":"The cacti ID of the uplink","readOnly":true},"aggregate":{"type":"boolean","description":"True if the uplink is an aggregated uplink, false if it is not aggregated","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}/host":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get all your hosts for given deployment environment","operationId":"getDeploymentEnvironmentHosts","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Host"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentEnvironment/{deploymentEnvironmentId}/application/inUse

> Get the list of in use applications for given deployment environment Id

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Application":{"type":"object","required":["id","type","managementProtocol","name","createdAt","inUse"],"properties":{"id":{"type":"string","format":"","description":"Application ID","readOnly":true},"type":{"type":"integer","format":"integer","description":"The list of application type can be found in: GET /application/type"},"managementProtocol":{"type":"integer","format":"integer","description":"The protocol used to manage the application (defaults to None when not set):\n* 0: None\n* 1: A2S\n* 2: ARCUS"},"name":{"type":"string","format":"","description":"The public name of your application"},"websiteUrl":{"type":"string","format":"","description":"The url to your application's website"},"description":{"type":"string","format":"","description":"A short description of your application"},"developerName":{"type":"string","format":"","description":"The name of the application's developer"},"publisherName":{"type":"string","format":"","description":"The name of the application's publisher"},"stopDefaultOsGroup":{"type":"integer","format":"integer","description":"The default operating system group being used for the stop method. If you have a Windows and Linux ApplicationBuild you can overwrite this on the ApplicationBuild level. Must be one of:\n* 1: Windows\n* 2: Linux (default)"},"stopMethod":{"type":"integer","format":"integer","description":"The stop method that will be used on restart or destroy of an application instance. The default is hard kill, list of types can be found in: [GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods)"},"stopTimeout":{"type":"integer","format":"integer","description":"The timeout that will be used on restart or destroy of an application instance, in seconds. The default is 0 (no timeout)"},"createdAt":{"type":"integer","format":"integer","description":"UnixTimestamp","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"If the application currently in use or not","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}/application/inUse":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get the list of in use applications for given deployment environment Id","operationId":"getDeploymentEnvironmentApplicationInUses","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Application"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentEnvironment/{deploymentEnvironmentId}/application/{applicationId}/fleet

> Get the list of fleet in a deployment environment, having a certain application of type game

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Fleet":{"type":"object","required":["id","name","deploymentEnvironmentId","operationalStatus","isGameLift"],"properties":{"id":{"type":"string","format":"","description":"Fleet ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the fleet"},"deploymentEnvironmentId":{"type":"string","format":"","description":"Deployment environment ID to which the fleet is assigned"},"deploymentProfileId":{"type":"string","format":"","description":"The `DeploymentProfileTemplate`'s ID, used for scaling, that is attached to this `Fleet`"},"gameDeploymentTemplateId":{"type":"string","format":"","description":"The `GameDeploymentTemplate`'s ID that is attached to this `Fleet`"},"utilityDeploymentTemplateId":{"type":"string","format":"","description":"The `UtilityDeploymentTemplate`'s ID that is attached to this `Fleet`"},"dependencyDeploymentTemplateId":{"type":"string","format":"","description":"The `DependencyDeploymentTemplate`'s ID that is attached to this `Fleet`"},"hostCapacityTemplateId":{"type":"string","format":"","description":"The `HostCapacityTemplate`'s ID that is attached to this `Fleet`"},"operationalStatus":{"type":"integer","format":"integer","description":"0: Manual, 1: Automatic deployment enabled, 2: Automatic scaling enabled (implies automatic deployment)","readOnly":true},"isGameLift":{"type":"boolean","description":"When it is active it cannot be disabled anymore"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}/application/{applicationId}/fleet":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get the list of fleet in a deployment environment, having a certain application of type game","operationId":"getDeploymentEnvironmentApplicationFleets","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}},{"name":"applicationId","in":"path","description":"The Id of the application","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Fleet"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId or applicationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentEnvironment/{deploymentEnvironmentId}/applicationBuild/inUse

> Get the list of in use application builds for a given deployment environment Id

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationBuild":{"type":"object","required":["id","name","applicationId","type","executable","osId","createdAt","runAsRoot"],"properties":{"id":{"type":"string","format":"","description":"Application build ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the application build"},"applicationId":{"type":"string","format":"","description":"The ID of the application. May be null if buildProvisioningStorageType is LegacyFTP","nullable":true},"hostCapacityTemplateId":{"type":"string","format":"","description":"The ID of the host capacity template"},"type":{"type":"integer","format":"integer","description":"The application build, list of types can be found in: [GET /application/type](#/Application/get_v3_application_type)","readOnly":true},"executable":{"type":"string","format":"","description":"The executable name including the path originating from the root directory of the software structure"},"startupParameters":{"type":"string","format":"","description":"The startup parameters required for an executable"},"instanceDoesReadyCallback":{"type":"integer","format":"integer","description":"Set to 1 if a deployed application instance will inform the platform it's done with initializing and is ready to\naccept players. Defaults to 0 if not set, which means an instance's status will go directly to ONLINE (4) after starting"},"installId":{"type":"integer","format":"integer","description":"ID of the application install (legacy FTP, will be removed, may not be updated)","deprecated":true},"osId":{"type":"integer","format":"integer","description":"ID of the operating system, list of operating systems can be found in: [GET\n/v3/operatingsystem](all#/OperatingSystem/get_v3_operatingsystem)"},"stopMethod":{"type":"integer","format":"integer","description":"The stop method that will be used on restart or destroy of an application instance. The default is taken from the value of\n[GET /v3/application/stopMethod](game-publisher#/Application/getApplicationStopMethods) - any value submitted here overrides that Application default","nullable":true},"stopTimeout":{"type":"integer","format":"integer","description":"The timeout that will be used on restart or destroy of an application instance. The default is taken from the value of\n`Application.stopTimeout` - any value submitted here overrides that Application default","nullable":true},"createdAt":{"type":"integer","format":"integer","description":"When the application build was created (unix timestamp)","readOnly":true},"label":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for application build selection / identification"},"applicationBuildFile":{"allOf":[{"$ref":"#/components/schemas/ApplicationBuildFile"}],"description":"The application build file to be used for the application instance","nullable":true},"buildProvisioningStorageType":{"type":"integer","format":"integer","description":"Type of storage being used [GET\n/v3/buildProvisioning/storage/registration/types](#/BuildProvisioning/getBuildProvisioningStorageRegistrationTypes). Default: 0"},"runAsRoot":{"type":"integer","format":"integer","description":"Controls whether to run this build as root or as a non-privileged user.\nWarning: This currently only works for builds deployed onto a Linux operating system. Windows builds will always run as administrator\n* 0: run as non-privileged user\n* 1: run as root user (default)"}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"ApplicationBuildFile":{"type":"object","required":["id","buildProvisioningFileId","buildProvisioningRegistrationId","fileName","fileSize","version","md5CheckSum","createdAt","changedAt","availableOnCDN"],"properties":{"id":{"type":"string","format":"","description":"Application build file ID","readOnly":true},"buildProvisioningFileId":{"type":"string","format":"","description":"ID of the uploaded file to the i3D.net storage. Cannot be updated once set"},"buildProvisioningRegistrationId":{"type":"string","format":"","description":"ID of the build provisioning registration. Cannot be updated once set"},"fileName":{"type":"string","format":"","description":"Name of the file"},"fileSize":{"type":"integer","format":"integer","description":"Size of the file","readOnly":true},"version":{"type":"string","format":"","description":"Version of the file"},"md5CheckSum":{"type":"string","format":"","description":"MD5 checksum of the file","readOnly":true},"path":{"type":"string","format":"","description":"location of the file"},"domain":{"type":"string","format":"","description":"The domain where the files are stored"},"dockerRepository":{"type":"string","format":"","description":"The docker repository that needs to be used","deprecated":true},"createdAt":{"type":"integer","format":"integer","description":"UNIX timestamp when the application build file has been created","readOnly":true},"changedAt":{"type":"integer","format":"integer","description":"UNIX timestamp when the application build file last has been changed","readOnly":true},"availableOnCDN":{"type":"integer","format":"integer","description":"the file is on the CDN when is 1.","readOnly":true}},"additionalProperties":false,"nullable":true},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}/applicationBuild/inUse":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get the list of in use application builds for a given deployment environment Id","operationId":"getDeploymentEnvironmentApplicationBuildInUses","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationBuild"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentEnvironment/{deploymentEnvironmentId}/deploymentProfile

> Get all the cloud deployment profiles you have created

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentProfile":{"type":"object","required":["id","fleetIds","name","strategyType","minimumCapacity","bufferValue","bufferValueType","markedForDeletion","inUse","deploymentRegions","createdAt"],"properties":{"id":{"type":"string","format":"","description":"The deployment profile ID","readOnly":true},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets in which this deployment profile is being used","readOnly":true},"name":{"type":"string","format":"","description":"This deployment profile's name"},"description":{"type":"string","format":"","description":"This deployment profile's description"},"strategyType":{"type":"integer","format":"integer","description":"Possible values:\n- 1: Round robin"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed for each deployment region in this deployment profile.\nCan be overridden per deployment region"},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in each region. Can be overridden per region.\n`Null` value means that there is no `maximumCapacity`","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Global buffer value, to be applied to individual deployment regions. Can be overridden per region"},"bufferValueType":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)"},"bufferValueMin":{"type":"integer","format":"integer","description":"The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"When `1`, `markedForDeletion` will propagate to all deployment regions of this deployment profile.\nScaling down will happen slowly as application instances get removed naturally.\nAfter all application instances are removed, the deployment profile is set to inactive","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment profile has no active application instances\n- 1: Deployment profile has active application instance(s)","readOnly":true},"deploymentRegions":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentRegion"},"description":"All deployment regions of this deployment profile","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of creation time","readOnly":true}},"additionalProperties":false},"DeploymentRegion":{"type":"object","required":["id","name","i3dDcLocationIds","markedForDeletion","inUse"],"properties":{"id":{"type":"string","format":"","description":"This deployment region's ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the deployment region"},"i3dDcLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"All the i3D.net DC location IDs configured for this deployment region. You can get available IDs via `GET /cloud/dcLocation`"},"i3dDcLocationIdsToBeRemoved":{"type":"array","items":{"type":"integer","format":"integer"},"description":"i3D.net data center location IDs scheduled for removal from this region"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed in this region.\n`Null` value means that the `minimumCapacity` provided in the deployment profile will persist","nullable":true},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in this region.\n`Null` value means that the `maximumCapacity` provided in the deployment profile will persist","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValue`, to be applied only to this deployment region.\n`Null` value means that the `bufferValue` provided in the deployment profile will persist","nullable":true},"bufferValueType":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueType`. Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)\n`Null` value means that the `bufferValueType` provided in the deployment profile will persist","nullable":true},"bufferValueMin":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMin`. The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low.\n`Null` value means that the `bufferValueMin` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMax`. The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high.\n`Null` value means that the `bufferValueMax` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"strategyType":{"type":"integer","format":"integer","description":"Override value for `DeploymentProfile.strategyType`. Possible values:\n- `0`: Use default\n- `1`: Round robin\n- `null`: The `strategyType` provided in the deployment profile will persist","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to `1`, all application instances will be gracefully removed inside the deployment region. Afterwards this deployment region will be set to inactive","readOnly":true},"containers":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainer"}},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment region has no active application instances\n- 1: Deployment region has active application instance(s)","readOnly":true}},"additionalProperties":false},"DeploymentContainer":{"type":"object","required":["id","markedForDeletion","containerLocations"],"properties":{"id":{"type":"string","format":"","description":"This deployment container's ID","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed inside the container. Afterwards this container will be set to inactive","readOnly":true},"containerLocations":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainerLocation"}}},"additionalProperties":false},"DeploymentContainerLocation":{"type":"object","required":["id","cloudProviderId","dcLocationId","primaryInstanceTypeName","primaryInstanceTypeStatus","secondaryInstanceTypeStatus","markedForDeletion"],"properties":{"id":{"type":"string","format":"","description":"This deploymentContainerLocation's ID","readOnly":true},"cloudProviderId":{"type":"integer","format":"integer","description":"The cloud provider ID of this location. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"dcLocationId":{"type":"integer","format":"integer","description":"The ID of the data center. Find all possible values from [`GET /v3/cloud/dcLocation`](#/Cloud/get_v3_cloud_dcLocation)"},"primaryInstanceTypeName":{"type":"string","format":"","description":"The primary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"primaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either primary instance type is available or not","readOnly":true},"secondaryInstanceTypeName":{"type":"string","format":"","description":"The secondary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"secondaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either secondary instance type is available or not","readOnly":true},"cpuPlatform":{"type":"string","format":"","description":"The CPU platform to use for the given `cloudProviderId`. Find all possible values from [`GET /v3/cloud/cpuPlatform`](#/Cloud/get_v3_cloud_cpuPlatform).\nNull value means that a CPU platform is chosen automatically by the cloud provider.\nNote that this selector is not available on all cloud platforms","nullable":true,"deprecated":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed in this cloud location. After all application instances are removed this object will also be deleted","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}/deploymentProfile":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get all the cloud deployment profiles you have created","operationId":"getDeploymentEnvironmentDeploymentProfiles","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentProfile"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Get all the application instances for the given deployment environment

> Note: bare metal servers and VMs are exposed in the same manner, as "dedicated servers". hostId can be found in the /host endpoint.

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentEnvironment","description":"All deployment environment endpoints"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"ApplicationInstance":{"type":"object","required":["id","deploymentEnvironmentId","deploymentEnvironmentName","fleetId","fleetName","hostId","isVirtual","applicationId","applicationName","applicationType","applicationBuildId","applicationBuildName","dcLocationId","dcLocationName","regionId","regionName","status","createdAt","startedAt","stoppedAt","pid","pidChangedAt","startupParams","executable","manuallyDeployed","properties","ipAddress","labelReadOnly","numPlayersMax","numPlayers","liveHostName","liveMap","liveGameVersion","updatedAt","liveRules","autoRestart","markedForDeletion","arcusAvailable"],"properties":{"id":{"type":"string","format":"","description":"Application instance ID","readOnly":true},"deploymentEnvironmentId":{"type":"string","format":"","description":"The deployment environment ID of this application instance","readOnly":true},"deploymentEnvironmentName":{"type":"string","format":"","description":"The deployment environment name of this application instance","readOnly":true},"fleetId":{"type":"string","format":"","description":"The fleet ID of this application instance","readOnly":true},"fleetName":{"type":"string","format":"","description":"The fleet name of this application instance","readOnly":true},"hostId":{"type":"integer","format":"integer","description":"The application instance is host on this server.","readOnly":true},"isVirtual":{"type":"integer","format":"integer","description":"0 if this instance runs on a bare metal server, 1 if it runs on a VM","readOnly":true},"applicationId":{"type":"string","format":"","description":"The application ID of this application instance","readOnly":true},"applicationName":{"type":"string","format":"","description":"The application name of this application instance","readOnly":true},"applicationType":{"type":"integer","format":"integer","description":"The type of the application, the different types can be found in:\n[GET /v3/application/type](game-publisher#/Application/getApplicationTypes)","readOnly":true},"applicationBuildId":{"type":"string","format":"","description":"The application build ID of this application instance","readOnly":true},"applicationBuildName":{"type":"string","format":"","description":"The application build name of this application instance","readOnly":true},"installId":{"type":"string","format":"","description":"ID of the application install","nullable":true,"deprecated":true},"dcLocationId":{"type":"integer","format":"integer","description":"The datacenter ID of where this application instance is located","readOnly":true},"dcLocationName":{"type":"string","format":"","description":"The datacenter name of where this application instance is located","readOnly":true},"regionId":{"type":"string","format":"","description":"The deployment region ID of where this application instance is located","readOnly":true},"regionName":{"type":"string","format":"","description":"The deployment region name of where this application instance is located","readOnly":true},"status":{"type":"integer","format":"integer","description":"The application instance status, list of application instance status can be found in\n[GET /v3/applicationInstance/status](game-publisher#/ApplicationInstance/getApplicationInstanceStatuses)","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"The Unix timestamp at which this application instance is created","readOnly":true},"startedAt":{"type":"integer","format":"integer","description":"The Unix timestamp at which this application instance is started","readOnly":true},"stoppedAt":{"type":"integer","format":"integer","description":"The Unix timestamp at which this application instance is stopped","readOnly":true},"pid":{"type":"integer","format":"integer","description":"The process ID of the application instance running on the host","readOnly":true},"pidChangedAt":{"type":"integer","format":"integer","description":"The Unix timestamp of the moment the process ID has been changed on the host","readOnly":true},"startupParams":{"type":"string","format":"","description":"The exact startup parameters that were used to start this application instance with all properties resolved to their\nrespective values. Will be `null` if the instance has not been started, but will retain its previous value if it was stopped. Once set it will never be\ncleared again","nullable":true,"readOnly":true},"executable":{"type":"string","format":"","description":"The name of the executable that was ran when the application instance started. Will be `null` if the instance has not been\nstarted, but will retain its previous value if it was stopped. Once set it will never be cleared again","nullable":true,"readOnly":true},"manuallyDeployed":{"type":"integer","format":"integer","description":"If set to `1`, the application instance was manually deployed, instead of automatically deployed through the system","readOnly":true},"properties":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationInstanceProperty"},"description":"Properties of application instance","readOnly":true},"ipAddress":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationInstanceIP"},"description":"List of IP addresses for an application instance","readOnly":true},"labelReadOnly":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Pre-defined key/value pairs that can be used for application selection / identification.\nAvailable labelReadOnly keys are:\n* application_id\n* fleet_id\n* host_id\n* dc_location_id\n* region_id\n* application_build_id","readOnly":true},"labelPublic":{"type":"array","items":{"$ref":"#/components/schemas/Label"},"description":"Custom key/value pairs that can be used for application instance selection / identification"},"metadata":{"type":"array","items":{"$ref":"#/components/schemas/Metadata"},"description":"Custom key/value pairs to be set or adjusted by the allocation call or the application instance itself. This metadata\nwill be passed to the application instance when starting it [needs more clarification]"},"numPlayersMax":{"type":"integer","format":"integer","description":"The maximum number of players on the application instance (this only apply to application instances of the type game)","readOnly":true},"numPlayers":{"type":"integer","format":"integer","description":"The number of online players on the application instance (this only apply to application instances of the type game)","readOnly":true},"liveHostName":{"type":"string","format":"","description":"The live host name of the application instance (this only apply to application instances of the type game)","readOnly":true},"liveMap":{"type":"string","format":"","description":"The live map of an application instance (this only apply to application instances of the type game)","readOnly":true},"liveGameVersion":{"type":"string","format":"","description":"The live game version of an application instance (this only apply to application instances of the type game)","readOnly":true},"updatedAt":{"type":"integer","format":"integer","description":"The Unix timestamp at which this application instance is live data is updated (this only apply to application instances of the type game)","readOnly":true},"liveRules":{"type":"string","format":"","description":"The live rules of an application instance (this only apply to application instances of the type game)","readOnly":true},"autoRestart":{"type":"integer","format":"integer","description":"If auto restart is `1` then the application instance will auto restart, when `0` the application instance auto restart will be disabled","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If an application will be deleted it will be `1`, `0` otherwise","readOnly":true},"arcusAvailable":{"type":"integer","format":"integer","description":"`1` if Arcus is available & running for this application instance, `0` otherwise.\nNote: If your application's `managementProtocol` is NOT set to Arcus, this value will always be `0`, even if your\ngame server would support the Arcus protocol. The protocol is only tested, and this value potentially be set to `1`,\nwhen the `managementProtocol` is set to Arcus.","readOnly":true}},"additionalProperties":false},"ApplicationInstanceProperty":{"type":"object","required":["id","propertyType","propertyKey","propertyValue"],"properties":{"id":{"type":"string","format":"","description":"The application instance property ID","readOnly":true},"propertyType":{"type":"integer","format":"integer","description":"The application instance property type. For a list of application property types see\n[`GET /v3/application/property/type`](#/Application/get_v3_application_property_type)","readOnly":true},"propertyKey":{"type":"string","format":"","description":"The application instance property key. Only hyphens (-), underscores (_), lowercase characters and numbers are allowed.\nKeys must start with a lowercase character"},"propertyValue":{"type":"string","format":"","description":"The application instance property value"}},"additionalProperties":false},"ApplicationInstanceIP":{"type":"object","required":["ipAddress","ipVersion","private"],"properties":{"ipAddress":{"type":"string","format":"","description":"Application instance IP address"},"ipVersion":{"type":"integer","format":"integer","description":"Application instance IP version","readOnly":true},"private":{"type":"integer","format":"integer","description":"If application instance has private ip address.","readOnly":true}},"additionalProperties":false},"Label":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Label key, only hyphens (-), underscores (_), lowercase characters and numbers are allowed. Keys must start with a lowercase character."},"value":{"type":"string","format":"","description":"Label value, maximum length is 150 characters"}},"additionalProperties":false},"Metadata":{"type":"object","required":["key","value"],"properties":{"key":{"type":"string","format":"","description":"Metadata key. Max length 50 characters"},"value":{"type":"string","format":"","description":"Metadata value. Max length 2048 bytes"}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentEnvironment/{deploymentEnvironmentId}/applicationInstance":{"get":{"tags":["DeploymentEnvironment"],"summary":"Get all the application instances for the given deployment environment","description":"Note: bare metal servers and VMs are exposed in the same manner, as \"dedicated servers\". hostId can be found in the /host endpoint.","operationId":"getDeploymentEnvironmentApplicationInstances","parameters":[{"name":"deploymentEnvironmentId","in":"path","description":"The Id of the deployment environment","required":true,"schema":{"type":"string"}},{"name":"labels","in":"query","description":"Label expressions can be used to apply more specific search parameters and can be written in standard SQL query language.<br />\nE.g. `region_id=123` or multiple filters: `region_id=123 and fleet_id=456 or host_id=46256` The provided filter query needs to be url encoded. E.g.<br />\n`region_id%3D123` or multiple filters: `region_id%3D123%20and%20fleet_id%3D456%20or%20host_id%3D46256` The total would look like:<br />\n`/deploymentEnvironment/{deploymentEnvironmentId}/applicationInstance?labels=region_id%3D123%20and%20fleet_id%3D456%20or%20host_id%3D46256`<br />\nIf you want to filter on a non-numeric label such as `region_name`, you have to wrap the value in double quotes: `region_name=\"Rotterdam\"`<br />\nWarning: the `labels` query parameter is ignored when passing a `PAGE-TOKEN` and the original `labels` string will be used for that request instead.<br />\nMore information on the use of labels can be found <a href=\"https://www.i3d.net/docs/one/odp/Platform-Elements/Application/Label/#pre-defined-labels\">here</a>.","schema":{"type":"string"}},{"name":"filters","in":"query","description":"Filter expression can be used to apply more specific search on most parameters in the application instance, it is written like<br />\nthis E.G. `regionId=123` or multiple filters: `regionId=123 and fleetId=456`, only the `AND` statement is supported at this time. You can also<br />\nsearch inside nested objects like `metaData.key=\"testing\"` and `metaData.value=\"test\"` You can only search on exact matches.<br />\nWarning: the `filters` query parameter is ignored when passing a `PAGE-TOKEN` and the original `filters` string will be used for that request<br />\ninstead.<br />\nWarning: filtering on the following parameters is currently not supported and will give an error:<br />\n`autoRestart`, `liveGameVersion`, `liveHostName`, `liveMap`, `liveRules`, `manuallyDeployed`, `markedForDeletion`, `numPlayers`, `numPlayersMax`,<br />\n`pid`, `pidChangedAt`, `startedAt`, `status`, `stoppedAt`, `updatedAt`","schema":{"type":"string"}},{"name":"sort","in":"query","description":"Sort expression to sort your results in the order that you like E.G. \"sort=fleetId=ASC and applicationId DESC\" Be aware that all filters<br />\nand sorting should be url encoded.<br />\nWarning: the `sort` query parameter is ignored when passing a `PAGE-TOKEN` and the original `sort` string will be used for that request instead<br />\nWarning: sorting on the following parameters is currently not supported and will give an error:<br />\n`autoRestart`, `liveGameVersion`, `liveHostName`, `liveMap`, `liveRules`, `manuallyDeployed`, `markedForDeletion`, `numPlayers`, `numPlayersMax`,<br />\n`pid`, `pidChangedAt`, `startedAt`, `status`, `stoppedAt`, `updatedAt`","schema":{"type":"string"}},{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA: <span style=\"text-decoration: line-through\">start=0,</span>results=25<br />\nWarning: the `start` variable of the `RANGED-DATA` object has been deprecated for this endpoint. It is not possible to supply a start, see<br />\n`PAGE-TOKEN` header for a replacement","schema":{"type":"string"}},{"name":"PAGE-TOKEN","in":"header","description":"This token will be provided by this endpoint to allow for pagination functionality. By performing a request to this endpoint<br />\nwithout the `PAGE-TOKEN` you will retrieve the first page of search results. If a `PAGE-TOKEN` is returned, a next page may be requested by<br />\nsupplying that token in the next request using the same `PAGE-TOKEN` key and value in the request header. If no `PAGE-TOKEN` is returned, the last<br />\npage has been reached and no further data can be requested. A returned `PAGE-TOKEN` is valid until the date specified in the `Expires` response<br />\nheader. Example: `PAGE-TOKEN: eyJjb25kaXRpb25zIjp7InVzZXJJZCI6NjY2ODI1fSwibGFiZWxz(...)` (truncated for readability)<br />\nExpires header example: `Expires: Fri, 08 Jan 2021 09:10:29 GMT`","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ApplicationInstance"}}}}},"400":{"description":"`PAGE-TOKEN` did not have an expected structure and is invalid. Please try again by sending a request without a `PAGE-TOKEN` and restarting"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentEnvironmentId"},"410":{"description":"`PAGE-TOKEN` is expired. Acquire a new `PAGE-TOKEN` by sending a request without a `PAGE-TOKEN` and try again"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.i3d.net/api-references/game/deploymentenvironment-1.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
